
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>自定义路由和负载均衡策略镜像acs/proxy 参考文档 / iVAN</title>

    <meta name="description" content="自定义路由和负载均衡策略镜像acs/proxy 参考文档 自定义路由-使用手册 acs/proxy 自定义代理镜像,通过 FROM dockercloud/haproxy 的方式继承自镜像 dockercloud/haproxy,动态感知容器的状态,做到后端容器负载均衡代理和服务发现.特点是将 HAProxy 负载均衡软件的所有配置都参数化了,方便您自定义自己的需求和配置. 该镜像主要用于 Alibaba Cloud 容器服务的默认路由服务不能满足您需求的场景,方便您对 HAProxy 进行自定义配置. 文档中会提到 acs/proxy 和 HAPro">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">自定义路由和负载均衡策略镜像acs/proxy 参考文档</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h1>自定义路由-使用手册</h1>
<h2>acs/proxy</h2>
<p>自定义代理镜像，通过 <code>FROM dockercloud/haproxy</code> 的方式继承自镜像 <code>dockercloud/haproxy</code>，动态感知容器的状态，做到后端容器负载均衡代理和服务发现。特点是将 HAProxy 负载均衡软件的所有配置都参数化了，方便您自定义自己的需求和配置。</p>
<p>该镜像主要用于 Alibaba Cloud 容器服务的默认路由服务不能满足您需求的场景，方便您对 HAProxy 进行自定义配置。</p>
<p>文档中会提到 acs/proxy 和 HAProxy，均指代该镜像或者镜像中的软件 HAProxy。</p>
<h2>动态负载均衡代理和服务发现的原理</h2>
<ul>
<li>镜像 <code>acs/proxy</code> 通过容器自身环境变量确定负载均衡的全局（GLOBAL）和默认（DEFAULT）配置。</li>
<li>镜像 <code>acs/proxy</code> 侦听集群中的事件，例如容器状态的变化，发生变化后重新获取集群中相关容器的信息，确定最新的负载均衡配置。</li>
<li>镜像 <code>acs/proxy</code> 根据最新的负载均衡配置去重新加载（reload）该配置，使得该配置生效。</li>
</ul>
<h2>如何确定负载均衡的后端容器</h2>
<ul>
<li>根据 <code>acs/proxy</code> 的环境变量 <code>ADDITIONAL_SERVICES</code> 来确定范围。</p>
<ul>
<li><code>ADDITIONAL_SERVICES: "*"</code> 表示范围为整个集群。</li>
<li><code>ADDITIONAL_SERVICES: "project_name1:service_name1,project_name2:service_name2"</code> 表示范围为当前应用和指定应用的指定服务。</li>
<li><code>ADDITIONAL_SERVICES</code> 不设置或者为空表示范围为当前应用的容器。</li>
</ul>
</li>
<li>根据每个容器的标签来确定是否加入 <code>acs/proxy</code> 的后端。
<ul>
<li><code>aliyun.proxy.VIRTUAL_HOST: "www.toolchainx.com"</code> 表示加入后端，且域名为 <code>www.toolchainx.com</code>。</li>
<li><code>aliyun.proxy.required: "true"</code> 表示加入后端，且作为默认的后端。</li>
</ul>
</li>
</ul>
<h2>如何在前端绑定负载均衡</h2>
<p>使用自定义负载均衡标签，例如 <code>aliyun.lb.port_80: 'tcp://proxy:80'</code>。</p>
<p>关于自定义负载均衡标签的使用方法，参见 lb 标签。</p>
<h2>示例模板</h2>
<pre><code> lb:
    image:  registry.aliyuncs.com/acs/proxy:0.5
    ports:
            -  '80:80'
    restart:  always
    labels:
        # addon 使得 proxy 镜像有订阅注册中心的能力，动态加载服务的路由
        aliyun.custom_addon:  "proxy"
        # 每台 vm 部署一个该镜像的容器
        aliyun.global:  "true"
        #  使用自定义负载均衡，前端绑定负载均衡
        aliyun.lb.port_80: tcp://proxy_test:80
    environment:
        #  支持加载路由的后端容器的范围，"*"表示整个集群，默认为应用内的服务
        ADDITIONAL_SERVICES:  "*"
appone:
    expose:  # 被代理的服务一定要使用 expose 或者 ports 告诉 proxy 容器暴露哪个端口
        -  80/tcp
    image:  'nginx:latest'
    labels:
        # 此处支持 http/https/ws/wss 协议
        # 必须使用您自己的域名而不是容器服务提供的测试域名
        aliyun.proxy.VIRTUAL_HOST:  "http://appone.example.com"
    restart:  always</code></pre>
<h2>配置说明</h2>
<h4>通过 <code>acs/proxy</code> 镜像的环境变量设置全局（GLOBAL）和默认（DEFAULT）配置</h4>
<blockquote><p><strong>注意：</strong>您需要重新部署 HAProxy 服务才能使此处的配置变更生效。该部分的配置针对的是镜像 <code>acs/proxy</code> 所在服务的环境变量配置。</p></blockquote>
<table>
<thead>
<tr>
<th>环境变量</th>
<th>默认值</th>
<th>描述</th>
</tr>
</thead>
<tbody>
<tr>
<td>ADDITIONAL_SERVICES</td>
<td> </td>
<td>需要进行负载均衡的附加服务列表 （比如：<code>prj1:web,prj2:sql</code>）。<br />服务发现将基于 com.docker.compose.[project|service] 容器标签。<br />该环境变量仅适用于 compose V2，且必须确保容器可以解析和访问依赖的服务所在的网络。</td>
</tr>
<tr>
<td>BALANCE</td>
<td>roundrobin</td>
<td>要使用的负载均衡算法。<br />可能的取值包括 <code>roundrobin</code>、<code>static-rr</code>、<code>source</code> 和 <code>leastconn</code>。<br />更多详细信息，参见 <a href="https://cbonte.github.io/haproxy-dconv/configuration-1.5.html?spm=5176.1972344.1.6.M5iZD7#4-balance" rel="external nofollow noreferrer">HAProxy：balance</a>。</td>
</tr>
<tr>
<td>CA_CERT_FILE</td>
<td> </td>
<td>CA 证书文件的路径。<br />通过使用该环境变量，您可以直接从数据卷挂载 CA 证书文件，而不需要通过环境变量传递证书文件内容。如果您设置了该变量，系统会忽略 <code>CA_CERT</code> 环境变量。<br />可设置为 <code>/cacerts/cert0.pem</code>。</td>
</tr>
<tr>
<td>CA_CERT</td>
<td> </td>
<td>HAProxy 用于验证客户端的 CA 证书。<br />该环境变量的格式与 <code>DEFAULT_SSL_CERT</code> 相同。</td>
</tr>
<tr>
<td>CERT_FOLDER</td>
<td> </td>
<td>证书的路径。<br />通过使用该变量，您可以直接从数据卷挂载 CA 证书文件，而不需要通过环境变量传递证书文件的内容。如果您设置了该变量，系统会忽略所依赖服务的 <code>DEFAULT_SSL_CERT</code> 和 <code>SSL_CERT</code> 环境变量。<br />可设置为 <code>/certs/</code>。</td>
</tr>
<tr>
<td>DEFAULT_SSL_CERT</td>
<td> </td>
<td>默认的 SSL 证书。<br />该 pem 文件包含私钥和公钥（其中，私钥在前，公钥在后），使用 <code>\n</code>（两个字符）作为行分隔符。内容应该写在同一行，参见 SSL Termination。</td>
</tr>
<tr>
<td>EXTRA_BIND_SETTINGS</td>
<td> </td>
<td>额外设置，由逗号进行分隔的字符串（<code>&lt;port&gt;:&lt;setting&gt;</code>）。每一部分会被附加到配置文件中对应的端口绑定节点。<br />如果需要使用逗号，需要使用 <code>\,</code> 进行转义。<br />可设置为 <code>443:accept-proxy, 80:name http</code>。</td>
</tr>
<tr>
<td>EXTRA_DEFAULT_SETTINGS</td>
<td> </td>
<td>额外设置，由逗号进行分隔的字符串。每一部分会被附加到配置文件中的 DEFAULT 节点。<br />如果需要使用逗号，需要使用 <code>\,</code> 进行转义。</td>
</tr>
<tr>
<td>EXTRA_FRONTEND_SETTINGS_&lt;PORT&gt;</td>
<td> </td>
<td>额外设置，由逗号进行分隔的字符串。每一部分会按照环境变量名称中指定的端口号被附加到前端节点。<br />如果需要使用逗号，需要使用 <code>\,</code> 进行转义。<br />可设置为 <code>EXTRA_FRONTEND_SETTINGS_80=balance source, maxconn 2000</code>。</td>
</tr>
<tr>
<td>EXTRA_GLOBAL_SETTINGS</td>
<td> </td>
<td>额外设置，由逗号进行分隔的字符串。每一部分会被附加到配置文件中的 GLOBAL 节点。<br />如果需要使用逗号，需要使用 <code>\,</code> 进行转义。<br />可设置为 <code>tune.ssl.cachesize 20000, tune.ssl.default-dh-param 2048</code>。</td>
</tr>
<tr>
<td>EXTRA_ROUTE_SETTINGS</td>
<td> </td>
<td>该字符串会在健康检查结束后被附加到每一个后端路由上。<br />依赖的服务中的设置会覆盖该设置。<br />可设置为 <code>"send-proxy"</code>。</td>
</tr>
<tr>
<td>EXTRA_SSL_CERTS</td>
<td> </td>
<td>多余证书的名称列表，由逗号分隔，例如 <code>CERT1, CERT2, CERT3</code>。<br />您还需要将每一个证书指定为单独的环境变量，例如 <code>CERT1="&lt;cert-body1&gt;"</code>, <code>CERT2="&lt;cert-body2&gt;"</code>, <code>CERT3="&lt;cert-body3&gt;"</code>。</td>
</tr>
<tr>
<td>HEALTH_CHECK</td>
<td>check</td>
<td>在每一个路由上设置健康检查。<br />可设置为 "check inter 2000 rise 2 fall 3"。<br />更多详细信息，参见 <a href="https://cbonte.github.io/haproxy-dconv/configuration-1.5.html?spm=5176.1972344.1.8.M5iZD7#5.2-check" rel="external nofollow noreferrer">HAProxy：check</a>。</td>
</tr>
<tr>
<td>HTTP_BASIC_AUTH</td>
<td> </td>
<td>HTTP 基本认证的身份信息列表，格式为 <code>&lt;user&gt;:&lt;pass&gt;</code>，由逗号分隔。该身份信息适用于所有后端路由。<br />如果需要使用逗号，需要使用 <code>\,</code> 进行转义。<br /><strong>注意：</strong>生产环境中，请不要使用该环境变量进行认证。</td>
</tr>
<tr>
<td>MAXCONN</td>
<td>4096</td>
<td>设置每个进程的最大同时连接数。</td>
</tr>
<tr>
<td>MODE</td>
<td>http</td>
<td>HAProxy 的负载均衡模式。<br />可能的值包括 <code>http</code>、<code>tcp</code> 和 <code>health</code>。</td>
</tr>
<tr>
<td>MONITOR_PORT</td>
<td> </td>
<td>要添加 <code>MONTIOR_URI</code> 的端口号。<br />该变量同 <code>MONTIOR_URI</code> 配合使用。<br />可设置为 <code>80</code>。</td>
</tr>
<tr>
<td>MONITOR_URI</td>
<td> </td>
<td>为获取 HAProxy 的健康状态所需要拦截的具体 URI。<br />更多详细信息，参见 <a href="http://cbonte.github.io/haproxy-dconv/configuration-1.5.html#4-monitor-uri" rel="external nofollow noreferrer">Monitor URI</a>。<br />可设置为 <code>/ping</code>。</td>
</tr>
<tr>
<td>OPTION</td>
<td>redispatch</td>
<td>
<code>default</code> 节点中的 HAProxy <code>option</code> 条目列表，由逗号分隔。</td>
</tr>
<tr>
<td>RSYSLOG_DESTINATION</td>
<td>127.0.0.1</td>
<td>HAProxy 日志将要发送到的 rsyslog 目的地址。</td>
</tr>
<tr>
<td colspan="2">SKIP_FORWARDED_PROTO</td>
<td>如果设置了该环境变量，HAProxy 将不会添加 X-Forwarded-For http请求头。<br />当 HAProxy 与其它负载均衡一同使用时，可以使用该环境变量。</td>
</tr>
<tr>
<td>SSL_BIND_CIPHERS</td>
<td> </td>
<td>设置 SSL 服务器所要使用的 SSL 密钥套件。<br />该环境变量设置了 HAProxy <code>ssl-default-bind-ciphers</code> 的配置。</td>
</tr>
<tr>
<td>SSL_BIND_OPTIONS</td>
<td>no-sslv3</td>
<td>设置 SSL 服务器所使用的 SSL 绑定选项。<br />该环境变量设置了 HAProxy <code>ssl-default-bind-options</code> 的配置。<br />设置为默认值则只允许在 SSL 服务器上使用 TLSv1.0+。</td>
</tr>
<tr>
<td>STATS_AUTH</td>
<td>stats:stats</td>
<td>访问 Haproxy stats 统计页面所需要的用户名和密码。</td>
</tr>
<tr>
<td>STATS_PORT</td>
<td>1936</td>
<td>HAProxy stats 统计页面暴露的端口号。如果开放了该端口，则可以通过 <code>http://&lt;host-ip&gt;:&lt;STATS_PORT&gt;/</code> 访问 stats统计页面。</td>
</tr>
<tr>
<td>TIMEOUT</td>
<td>connect 5000, client 50000, server 50000</td>
<td>
<code>default</code> 节点中 HAProxy <code>timeout</code> 条目列表，由逗号分隔。</td>
</tr>
</tbody>
</table>
<h3>被代理的后端服务通过相应服务镜像的标签（LABEL）进行某一后端服务的配置</h3>
<p>即通过将标签（LABEL）写到后端服务的镜像上来进行配置。该部分的配置写在被代理的服务的模版部分</p>
<p>此处的设置可以覆盖 HAProxy 的设置。HAProxy 的设置仅适用于依赖的服务。如果在阿里云容器服务上运行，当服务重新部署，加入或者退出 HAProxy 服务时，HAProxy 服务会自动进行更新来应用这些变更。</p>
<table>
<thead>
<tr>
<th>标签</th>
<th>描述</th>
</tr>
</thead>
<tbody>
<tr>
<td>aliyun.proxy.APPSESSION</td>
<td>会话保持选项。<br />可设置为 <code>JSESSIONID len 52 timeout 3h</code>。<br />更多详细信息，参见 <a href="http://cbonte.github.io/haproxy-dconv/configuration-1.5.html#4-appsession" rel="external nofollow noreferrer">HAProxy:appsession</a>。</td>
</tr>
<tr>
<td>aliyun.proxy.BALANCE</td>
<td>要使用的负载均衡算法。<br />可设置为 <code>roundrobin</code>、<code>static-rr</code>、<code>source</code> 和 <code>leastconn</code>。<br />更多详细信息，参见 <a href="https://cbonte.github.io/haproxy-dconv/configuration-1.5.html#4-balance" rel="external nofollow noreferrer">HAProxy:balance</a>。</td>
</tr>
<tr>
<td>aliyun.proxy.COOKIE</td>
<td>会话保持选项。<br />可设置为 <code>SRV insert indirect nocache</code>。<br />更多详细信息，参见 <a href="http://cbonte.github.io/haproxy-dconv/configuration-1.5.html#4-cookie" rel="external nofollow noreferrer">HAProxy:cookie</a>。</td>
</tr>
<tr>
<td>aliyun.proxy.DEFAULT_SSL_CERT</td>
<td>与 <code>SSL_CERT</code> 类似。但是该变量将 pem 文件保存在 <code>/certs/cert0.pem</code> 下作为默认的 SSL 证书。<br />如果在依赖的服务或者HAProxy 中设置了多个 <code>DEFAULT_SSL_CERT</code>，会导致未定义的行为。</td>
</tr>
<tr>
<td>aliyun.proxy.EXCLUDE_PORTS</td>
<td>端口号，由逗号分隔（例如：3306, 3307）。<br />默认情况下，HAProxy 将应用服务暴露的所有端口添加到后端路由。您可以指定您不希望进行路由的端口，比如数据库端口。</td>
</tr>
<tr>
<td>aliyun.proxy.EXTRA_ROUTE_SETTINGS</td>
<td>该字符串会在健康检查结束后被附加到每一个后端路由上。<br />可设置为 "send-proxy"。</td>
</tr>
<tr>
<td>aliyun.proxy.EXTRA_SETTINGS</td>
<td>额外设置，由逗号分隔。<br />每一部分会被附加到配置文件中相关的后端节点或监听会话。<br />如果需要使用逗号，使用 <code>\,</code> 进行转义。<br />可设置为 <code>balance source</code>。</td>
</tr>
<tr>
<td>aliyun.proxy.FORCE_SSL</td>
<td>如果设置了该环境变量且启用了 SSL termination，HAProxy 会将 HTTP 请求重定向为 HTTPS 请求。</td>
</tr>
<tr>
<td>aliyun.proxy.GZIP_COMPRESSION_TYPE</td>
<td>启用 gzip 压缩。<br />该环境变量的值为将要压缩的 MIME 类型列表。<br />可设置为 <code>text/html text/plain text/css</code>。</td>
</tr>
<tr>
<td>aliyun.proxy.HEALTH_CHECK</td>
<td>在每一个后端路由上设置健康检查。<br />可设置为 "check inter 2000 rise 2 fall 3"。<br />更多详细信息，参见 <a href="https://cbonte.github.io/haproxy-dconv/configuration-1.5.html#5.2-check" rel="external nofollow noreferrer">HAProxy:check</a>。</td>
</tr>
<tr>
<td>aliyun.proxy.HSTS_MAX_AGE</td>
<td>启用 HSTS。<br />该环境变量的值为一个整数，代表 HSTS 的有效期，单位为秒。<br />可设置为 <code>31536000</code>。</td>
</tr>
<tr>
<td>aliyun.proxy.HTTP_CHECK</td>
<td>启用 HTTP 协议来检查服务器的健康情况。<br />可设置为 "OPTIONS * HTTP/1.1rnHost: www"。<br />更多详细信息，参见 <a href="https://cbonte.github.io/haproxy-dconv/configuration-1.5.html#4-option%20httpchk" rel="external nofollow noreferrer">HAProxy:httpchk</a>。</td>
</tr>
<tr>
<td>aliyun.proxy.OPTION</td>
<td>HAProxy <code>option</code> 条目列表，由逗号分隔。<br />此处设置的 <code>option</code> 会被添加到相关的后端节点或监听节点，并会覆盖 HAProxy 容器中的 OPTION 设置。</td>
</tr>
<tr>
<td>aliyun.proxy.SSL_CERT</td>
<td>SSL 证书。该 pem 文件包含私钥和公钥（其中，私钥在前，公钥在后），使用 <code>\n</code> （两个字符）作为行分隔符。</td>
</tr>
<tr>
<td>aliyun.proxy.TCP_PORTS</td>
<td>由逗号分隔的端口（比如：9000, 9001, 2222/ssl）。<br /><code>TCP_PORTS</code> 中列出的端口将在 TCP 模式下被负载均衡。<br />以 <code>/ssl</code> 结尾的端口表示该端口需要 SSL termination。</td>
</tr>
<tr>
<td>aliyun.proxy.VIRTUAL_HOST_WEIGHT</td>
<td>虚拟主机的权重，同 <code>aliyun.proxy.VIRTUAL_HOST</code> 配合使用。<br />该值为一个整数，默认值为 0。<br />该设置会影响虚拟主机的 ACL 规则的顺序。 虚拟主机的权重越高，ACL 规则的优先级越高，即值越大，越先被路由到。</td>
</tr>
<tr>
<td>aliyun.proxy.VIRTUAL_HOST</td>
<td>指定虚拟主机和虚拟路径。<br />格式为 <code>[scheme://]domain[:port][/path], ...</code>。<br />可以在 <code>domain</code> 和 <code>path</code> 部分使用通配符 <code>*</code>。</td>
</tr>
</tbody>
</table>
<p>有关以上内容的更多信息，参见 <a href="http://cbonte.github.io/haproxy-dconv/configuration-1.5.html" rel="external nofollow noreferrer">HAProxy 配置手册</a>。</p>
<h2>虚拟主机和虚拟路径</h2>
<p>您可以在 <code>VIRTUAL_HOST</code> 环境变量中同时指定虚拟主机和虚拟路径。该变量的值由 URL 组成，多个 URL 之前用逗号分隔，格式为 <code>[scheme://]domain[:port][/path]</code>。</p>
<table>
<thead>
<tr>
<th>条目</th>
<th>默认值</th>
<th>描述</th>
</tr>
</thead>
<tbody>
<tr>
<td>scheme</td>
<td>http</td>
<td>可能的值包括 <code>http</code>、<code>https</code> 和 <code>wss</code>。</td>
</tr>
<tr>
<td colspan="2">domain</td>
<td>虚拟主机。可以使用通配符 <code>*</code>。</td>
</tr>
<tr>
<td>port</td>
<td>80/433</td>
<td>虚拟主机的端口号。当 <code>scheme</code> 设置为 <code>https</code> 或 <code>wss</code> 时，默认的端口为 <code>443</code>。</td>
</tr>
<tr>
<td colspan="2">/path</td>
<td>虚拟路径。以 <code>/</code> 开头，可以使用通配符 <code>*</code>。</td>
</tr>
</tbody>
</table>
<h4>匹配示例</h4>
<table>
<thead>
<tr>
<th>虚拟主机</th>
<th>匹配</th>
<th>不匹配</th>
</tr>
</thead>
<tbody>
<tr>
<td><code>http://domain.com</code></td>
<td><code>domain.com</code></td>
<td><code>www.domain.com</code></td>
</tr>
<tr>
<td><code>domain.com</code></td>
<td><code>domain.com</code></td>
<td><code>www.domain.com</code></td>
</tr>
<tr>
<td><code>domain.com:90</code></td>
<td><code>domain.com:90</code></td>
<td><code>domain.com</code></td>
</tr>
<tr>
<td><code>https://domain.com</code></td>
<td><code>https://domain.com</code></td>
<td><code>domain.com</code></td>
</tr>
<tr>
<td><code>https://domain.com:444</code></td>
<td><code>https://domain.com:444</code></td>
<td><code>https://domain.com</code></td>
</tr>
<tr>
<td><code>\*.domain.com</code></td>
<td><code>www.domain.com</code></td>
<td><code>domain.com</code></td>
</tr>
<tr>
<td><code>\*domain.com</code></td>
<td>
<code>www.domain.com</code>、<code>domain.com</code>、<code>anotherdomain.com</code>
</td>
<td><code>www.abc.com</code></td>
</tr>
<tr>
<td><code>www.e\*e.com</code></td>
<td>
<code>www.domain.com</code>、<code>www.exxe.com</code>
</td>
<td><code>www.axxa.com</code></td>
</tr>
<tr>
<td><code>www.domain.\*</code></td>
<td>
<code>www.domain.com</code>、<code>www.domain.org</code>
</td>
<td><code>domain.com</code></td>
</tr>
<tr>
<td><code>\*</code></td>
<td colspan="2">any website with HTTP</td>
</tr>
<tr>
<td><code>https://\*</code></td>
<td colspan="2">any website with HTTPS</td>
</tr>
<tr>
<td><code>\*/path</code></td>
<td>
<code>domain.com/path</code>、<code>domain.org/path?u=user</code>
</td>
<td><code>domain.com/path/</code></td>
</tr>
<tr>
<td><code>\*/path/</code></td>
<td>
<code>domain.com/path/</code>、<code>domain.org/path/?u=user</code>
</td>
<td>
<code>domain.com/path</code>、<code>domain.com/path/abc</code>
</td>
</tr>
<tr>
<td><code>\*/path/\*</code></td>
<td>
<code>domain.com/path/</code>、<code>domain.org/path/abc</code>
</td>
<td><code>domain.com/abc/path/</code></td>
</tr>
<tr>
<td><code>\*/\*/path/\*</code></td>
<td>
<code>domain.com/path/</code>、<code>domain.org/abc/path/</code>、 <code>domain.net/abc/path/123</code>
</td>
<td><code>domain.com/path</code></td>
</tr>
<tr>
<td><code>\*/\*.js</code></td>
<td>
<code>domain.com/abc.js</code>、<code>domain.org/path/abc.js</code>
</td>
<td><code>domain.com/abc.css</code></td>
</tr>
<tr>
<td><code>\*/\*.do/</code></td>
<td>
<code>domain.com/abc.do/</code>、 <code>domain.org/path/abc.do/</code>
</td>
<td><code>domain.com/abc.do</code></td>
</tr>
<tr>
<td><code>\*/path/\*.php</code></td>
<td><code>domain.com/path/abc.php</code></td>
<td>
<code>domain/abc.php</code>、<code>domain.com/root/abc.php</code>
</td>
</tr>
<tr>
<td><code>\*.domain.com/\*.jpg</code></td>
<td>
<code>www.domain.com/abc.jpg</code>、<code>abc.domain.com/123.jpg</code>
</td>
<td><code>domain.com/abc.jpg</code></td>
</tr>
<tr>
<td><code>\*/path, \*/path/</code></td>
<td colspan="2">
<code>domain.com/path</code>、<code>domain.org/path/</code>
</td>
</tr>
<tr>
<td>
<code>domain.com:90</code>、<code>https://domain.com</code>
</td>
<td>
<code>domain.com:90</code>、<code>https://domain.com</code>
</td>
<td> </td>
<td> </td>
</tr>
</tbody>
</table>
<blockquote><p><strong>注意：</strong></p></blockquote>
<ul>
<li>基于 <code>VIRTUAL_HOST</code> 所生成的 ACL 规则的顺序是随机的。在 HAProxy 中，当范围较窄的规则（比如 <code>web.domain.com</code>）被放置在范围较宽的规则（比如 <code>*.domain.com</code>）之后时， 系统永远不会达到范围较窄的规则。因此，如果您所设置的虚拟主机包含相互重叠的范围时，您需要使用 <code>VIRTUAL_HOST_WEIGHT</code> 来手动设置 ACL 规则的顺序，为范围较窄的虚拟主机设置高于范围较宽的虚拟主机的权重。</li>
<li>所有带有相同 <code>VIRTUAL_HOST</code> 环境变量设置的服务将被看做并合并为一个服务。这对于一些测试场景比较适用。</li>
</ul>
<h2>SSL termination</h2>
<p><code>acs/proxy</code> 支持证书的 SSL ternimation。您只需要为每一个需要使用 SSL ternimation 的应用设置 <code>SSL_CERT</code> 和 <code>VIRTUAL_HOST</code> 即可。然后，HAProxy 会读取依赖环境中的证书并开启 SSL ternimation。</p>
<p><strong>注意：</strong> 当环境变量的值中包含等号（=）时（这种情况在 <code>SSL_CERT</code>中很普遍），Docker 会跳过该环境变量。因此，您只能在 Docker 1.7.0 或更高版本上使用多 SSL ternimation。</p>
<p>在以下情况下会启用 SSL ternimation：</p>
<ul>
<li>至少设置了一个 SSL 证书。</li>
<li>没有设置 <code>VIRTUAL_HOST</code> 或者设置为使用 HTTPS 协议。</li>
</ul>
<p>您可以通过以下方法设置 SSL 证书：</p>
<ul>
<li>在 <code>acs/proxy</code> 中设置 <code>DEFAULT_SSL_CERT</code>。</li>
<li>在依赖于 <code>acs/proxy</code> 的应用服务中设置 <code>aliyun.proxy.SSL_CERT</code> 和/或 <code>DEFAULT_SSL_CERT</code>。</li>
</ul>
<p><code>aliyun.proxy.SSL_CERT</code> 和 <code>DEFAULT_SSL_CERT</code> 的区别在于 <code>SSL_CERT</code> 指定的多个证书保存为 <code>cert1.pem, cert2.pem, ...</code>，而 <code>DEFAULT_SSL_CERT</code> 指定的证书通常保存为 <code>cert0.pem</code>。在这种情况下，当没有设置 SNI 匹配时，HAProxy 会将 <code>cert0.pem</code> 用作默认证书。然而，当提供了多个 <code>DEFAULT_SSL_CERTIFICATE</code> 时，仅有其中一个证书可以保存为 <code>cert0.pem</code>，其它的证书将被弃用。</p>
<h4>PEM 文件</h4>
<p><code>acs/proxy</code> 或依赖的应用服务所指定的证书为一个 pem 文件。该文件包含私钥和公钥（其中，私钥必须放在公钥和其它许可证书的前面）。您可以运行下面的脚本生成一个自签名证书。</p>
<pre><code>openssl req -x509 -newkey rsa:2048 -keyout key.pem -out ca.pem -days 1080 -nodes -subj '/CN=*/O=My Company Name LTD./C=US'
cp key.pem cert.pem
cat ca.pem &gt;&gt; cert.pem
</code></pre>
<p>您获取 pem 文件之后，可以运行下面的命令将文件转化为一行内容。</p>
<pre><code>awk 1 ORS='\\n' cert.pem
</code></pre>
<p>拷贝转换后的内容并将其设置为 <code>aliyun.proxy.SSL_CERT</code> 或 <code>DEFAULT_SSL_CERT</code> 的值。</p>
<h2>亲和性和会话保持</h2>
<p>您可以通过以下任一方法设置亲和性和会话保持。</p>
<ul>
<li>在您的应用服务中设置 <code>aliyun.proxy.BALANCE=source</code>。当设置了 <code>source</code> 负载均衡方法时， HAProxy 会对客户端 IP 地址进行哈希并确保同一个 IP 总是连接到同一个后端服务容器上。</li>
<li>设置 <code>aliyun.proxy.APPSESSION=&lt;value&gt;</code>。使用应用会话来确定客户端应该连接到哪一个服务容器上。<code>&lt;value&gt;</code> 可以设置为 <code>JSESSIONID len 52 timeout 3h</code>。</li>
<li>设置 <code>aliyun.proxy.COOKIE=&lt;value&gt;</code>。使用应用 cookie 来确定客户端应该连接到哪一个后端服务容器上。<code>&lt;value&gt;</code> 可以设置为 <code>SRV insert indirect nocache</code>。</li>
</ul>
<p>更多详细信息，参见 <a href="http://cbonte.github.io/haproxy-dconv/configuration-1.5.html#4-appsession" rel="external nofollow noreferrer">HAProxy:appsession</a> 和 <a href="http://cbonte.github.io/haproxy-dconv/configuration-1.5.html#4-cookie" rel="external nofollow noreferrer">HAProxy:cookie</a>。</p>
<h2>TCP 负载均衡</h2>
<p>默认情况下，<code>acs/proxy</code> 运行在 <code>http</code> 模式下。如果您希望依赖的服务运行在 <code>tcp</code> 模式下，您可以指定 <code>TCP_PORTS</code> 环境变量。该变量的值为以逗号分隔的端口号（9000, 9001）。</p>
<p>例如，如果您运行以下命令：</p>
<pre><code>docker --name app-1 --expose 9000 --expose 9001 -e TCP_PORTS="9000, 9001" your_app
docker --name app-2 --expose 9000 --expose 9001 -e TCP_PORTS="9000, 9001" your_app
docker run --link app-1:app-1 --link app-2:app-2 -p 9000:9000, 9001:9001 acs/proxy
</code></pre>
<p>HAProxy 将分别在 9000 端口和 9001 端口上对 <code>app-1</code> 和 <code>app-2</code> 进行负载均衡。</p>
<p>此外，如果您所暴露的端口多于 <code>TCP_PORTS</code> 中所设置的端口，剩余的端口将会使用 <code>http</code> 模式进行负载均衡。</p>
<p>例如，如果您运行以下命令：</p>
<pre><code>docker --name app-1 --expose 80 --expose 22 -e TCP_PORTS=22 your_app
docker --name app-2 --expose 80 --expose 22 -e TCP_PORTS=22 your_app
docker run --link app-1:app-2 --link app-2:app-2 -p 80:80 -p 22:22 acs/proxy
</code></pre>
<p>HAProxy 会在 80 端口使用 <code>http</code> 模式进行负载均衡，在 22 端口使用 <code>tcp</code> 模式进行负载均衡。</p>
<p>通过这种方法，您可以同时使用 <code>tcp</code> 模式和 <code>http</code> 模式进行负载均衡。</p>
<p>如果您在 <code>TCP_PORTS</code> 中设置了以 <code>/ssl</code> 结尾的端口，比如 <code>2222/ssl</code>，HAProxy 会在 2222 端口上设置 SSL termination。</p>
<blockquote><p><strong>注意：</strong></p></blockquote>
<ul>
<li>您可以同时设置 <code>VIRTUAL_HOST</code> 和 <code>TCP_PORTS</code>，以便为 <code>http</code> 模式提供更多的管控。</li>
<li><code>tcp</code> 端口上的负载均衡适用于所有的服务。因此，如果您依赖了两个或多个使用同一 <code>TCP_PORTS</code> 设置的不同服务，<code>acs/proxy</code> 会将这些服务看做同一个服务。</li>
</ul>
<h2>WebSocket 支持</h2>
<p>您可以通过以下任一方法启用 websocket 支持：</p>
<ul>
<li>鉴于 Websocket 使用 HTTP 协议进行启动，您可以使用虚拟主机来指定使用 <code>ws</code> 或 <code>wss</code> 协议。比如，<code>-e VIRTUAL_HOST="ws://ws.domain.com, wss://wss.domain.com"</code>。</li>
<li>鉴于 Websocket 本身为 TCP 连接，因此您可以尝试使用本文档前面所介绍的 TCP 负载均衡。</li>
</ul>
<h2>使用场景示例</h2>
<blockquote><p><strong>注意：</strong></p></blockquote>
<ul>
<li>一下示例中的<code>acs/proxy</code>镜像均是<code>registry.aliyuncs.com/acs/proxy:0.5</code>的简写形式，请做相应替换。</li>
</ul>
<h4>我的 webapp 容器暴露了 8080 端口（或任意其它端口），我希望 proxy 监听 80 端口</h4>
<p>使用下面的命令：</p>
<pre><code>docker run -d --expose 80 --name webapp dockercloud/hello-world
docker run -d --link webapp:webapp -p 80:80 acs/proxy
</code></pre>
<h4>我的 webapp 容器暴露了 80 端口和 8083/8086 数据库端口，我希望 proxy 监听 80 端口并且不希望将数据库端口加入 acs/proxy</h4>
<pre><code>docker run -d -e EXCLUDE_PORTS=8803,8806 --expose 80 --expose 8033 --expose 8086 --name webapp dockercloud/hello-world
docker run -d --link webapp:webapp -p 80:80 acs/proxy
</code></pre>
<h4>我的容器暴露了 8080 端口（或任意其它端口），我希望 acs/proxy 监听 8080 端口</h4>
<p>使用下面的命令：</p>
<pre><code>docker run -d --expose 8080 --name webapp your_app
docker run -d --link webapp:webapp -p 8080:80 acs/proxy
</code></pre>
<h4>我希望 acs/proxy 处理 SSL 连接并将我的普通 HTTP 请求转发到端口 8080（或任意其它端口）</h4>
<p>使用下面的命令：</p>
<pre><code>docker run -d -e SSL_CERT="YOUR_CERT_TEXT" --name webapp dockercloud/hello-world
docker run -d --link webapp:webapp -p 443:443 -p 80:80 acs/proxy
</code></pre>
<p>或者</p>
<pre><code>docker run -d --link webapp:webapp -p 443:443 -p 80:80 -e DEFAULT_SSL_CERT="YOUR_CERT_TEXT" acs/proxy
</code></pre>
<p><code>YOUR_CERT_TEXT</code> 中的证书包含私钥和公钥（其中，私钥在前，公钥在后）。您需要在证书的行与行之间加上 <code>\n</code>。假设您的证书保存在 <code>~/cert.pem</code> 中，您可以运行以下命令。</p>
<pre><code>docker run -d --link webapp:webapp -p 443:443 -p 80:80 -e DEFAULT_SSL_CERT="$(awk 1 ORS='\\n' ~/cert.pem)" acs/proxy
</code></pre>
<h4>我希望 acs/proxy 终结 SSL 连接并将 HTTP 请求重定向为 HTTPS 请求</h4>
<p>使用下面的命令：</p>
<pre><code>docker run -d -e FORCE_SSL=yes -e SSL_CERT="YOUR_CERT_TEXT" --name webapp dockercloud/hello-world
docker run -d --link webapp:webapp -p 443:443 acs/proxy
</code></pre>
<h4>我希望从数据卷中加载我的 SSL 证书，而不是通过环境变量来传递证书内容</h4>
<p>您可以使用 <code>CERT_FOLDER</code> 环境变量来指定证书挂载在容器的哪个文件夹中。使用以下命令。</p>
<pre><code>docker run -d --name webapp dockercloud/hello-world
docker run -d --link webapp:webapp -e CERT_FOLDER="/certs/" -v $(pwd)/cert1.pem:/certs/cert1.pem -p 443:443 acs/proxy
</code></pre>
<h4>我希望通过域名设置虚拟主机路由</h4>
<p>可以通过 proxy 读取依赖的容器的环境变量（<code>VIRTUAL_HOST</code>）来配置虚拟主机。</p>
<p>示例：</p>
<pre><code>docker run -d -e VIRTUAL_HOST="www.webapp1.com, www.webapp1.org" --name webapp1 dockercloud/hello-world
docker run -d -e VIRTUAL_HOST=www.webapp2.com --name webapp2 your/webapp2
docker run -d --link webapp1:webapp1 --link webapp2:webapp2 -p 80:80 acs/proxy
</code></pre>
<p>在上面的例子中，当您访问 <code>http://www.webapp1.com</code> 或 <code>http://www.webapp1.org</code> 时，将显示运行于容器 <code>webapp1</code> 上的服务，<code>http://www.webapp2.com</code> 会连接到容器 <code>webapp2</code>。</p>
<p>如果您使用下面的命令：</p>
<pre><code>docker run -d -e VIRTUAL_HOST=www.webapp1.com --name webapp1 dockercloud/hello-world
docker run -d -e VIRTUAL_HOST=www.webapp2.com --name webapp2-1 dockercloud/hello-world
docker run -d -e VIRTUAL_HOST=www.webapp2.com --name webapp2-2 dockercloud/hello-world
docker run -d --link webapp1:webapp1 --link webapp2-1:webapp2-1 --link webapp2-2:webapp2-2 -p 80:80 acs/proxy
</code></pre>
<p>当您访问 <code>http://www.webapp1.com</code> 时，将显示运行于容器 <code>webapp1</code> 上的服务， <code>http://www.webapp2.com</code> 将基于轮询调度算法（或者任何其它 <code>BALANCE</code> 指定的算法）连接到容器 <code>webapp2-1</code> 和 <code>webapp2-2</code> 上。</p>
<h4>我希望我所有的 <code>*.node.io</code> 域名均指向我的服务</h4>
<pre><code>docker run -d -e VIRTUAL_HOST="*.node.io" --name webapp dockercloud/hello-world
docker run -d --link webapp:webapp -p 80:80 acs/proxy
</code></pre>
<h4>我希望 <code>web.domain.com</code> 连接到一个服务， <code>*.domain.com</code> 连接到另外一个服务</h4>
<pre><code>docker run -d -e VIRTUAL_HOST="web.domain.com" -e VIRTUAL_HOST_WEIGHT=1 --name webapp dockercloud/hello-world
docker run -d -e VIRTUAL_HOST="*.domain.com" -e VIRTUAL_HOST_WEIGHT=0 --name app dockercloud/hello-world
docker run -d --link webapp:webapp --link app:app -p 80:80 acs/proxy
</code></pre>
<h4>我希望所有到 <code>/path</code> 路径的请求均指向我的服务</h4>
<pre><code>docker run -d -e VIRTUAL_HOST="*/path, */path/*" --name webapp dockercloud/hello-world
docker run -d --link webapp:webapp -p 80:80 acs/proxy
</code></pre>
<h4>我希望所有的静态 html 请求均指向我的服务</h4>
<pre><code>docker run -d -e VIRTUAL_HOST="*/*.htm, */*.html" --name webapp dockercloud/hello-world
docker run -d --link webapp:webapp -p 80:80 acs/proxy
</code></pre>
<h4>我希望查看 HAProxy stats</h4>
<pre><code>docker run -d --link webapp:webapp -e STATS_AUTH="auth:auth" -e STATS_PORT=1936 -p 80:80 -p 1936:1936 acs/proxy
</code></pre>
<h4>我希望将我的日志发送到 papertrailapp</h4>
<p>用与您的 papertrailapp 账号相匹配的值替换 <code>&lt;subdomain&gt;</code> 和 <code>&lt;port&gt;</code>。</p>
<pre><code>docker run -d --name web1 dockercloud/hello-world
docker run -d --name web2 dockercloud/hello-world
docker run -it --env RSYSLOG_DESTINATION='&lt;subdomain&gt;.papertrailapp.com:&lt;port&gt;' -p 80:80 --link web1:web1 --link web2:web2 acs/proxy
</code></pre>
<h2>使用虚拟主机的拓扑图</h2>
<p>阿里云容器服务代理拓扑图</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZG9jcy1hbGl5dW4uY24taGFuZ3pob3Uub3NzLmFsaXl1bi1pbmMuY29tL2Fzc2V0cy9waWMvNTAzMDkvY25femgvMTQ4NjU0MTgzMzI3OC9JbWFnZSUyMDYucG5n.jpg"></p>
<h2>手动重新加载 HAProxy</h2>
<p>在大多数情况下，当依赖的服务发生变化时，<code>acs/proxy</code> 会自动进行配置。但是如果需要的话，您也可以按照下面的方法手动重新加载 <code>acs/proxy</code>。</p>
<p><code>docker exec &lt;acs/proxy_container_id&gt; /reload.sh</code></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-01 04:45:45</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%ae%b9%e5%99%a8%e6%9c%8d%e5%8a%a1/" title="容器服务">容器服务</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>自定义路由和负载均衡策略镜像acs/proxy 参考文档的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn7G2kz.html" rel="bookmark">阿里云容器服务--自定义路由和负载均衡策略</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				简单示例 让我们先从一个简单的例子开始,我们会部署一个acs/proxy容器,容器前面配置一个slb实例,让大家可以访问,同时在后端挂上一个nginx,这里我们只展示nginx的首页. compose模板如下所示: lb: image: registry.aliyuncs.com/acs/proxy:0.5 ports: - '80:80' restart: always labels: # addon 使得proxy镜像有订阅注册中心的能力,动态加载服务的路由 aliyun.custom_ad			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVnGoDz.html" rel="bookmark">用eigrp做不等值路由的负载均衡</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在eigrp中如何做到不等值路由的负载均衡 EIGRP Load Balancing 每个路由协议都支持等值路径的负载均衡.除此之外,IGRP和EIGRP也支持不等值路径的负载均衡,使用variance命令. Variance命令向路由器通告一个n值,n值使用variance命令指定.n值为1-128之间,默认为1. 网络拓扑 Variance 在上图中,router E有三个路径到网络X • E-B-A with a metric of 30 • E-C-A with a metric of			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPB6oqb.html" rel="bookmark">Ribbon负载均衡策略配置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在这里吐槽一句:网上很多文章真是神坑,你不看还好,看了只会问题越来越多,就连之前的问题都没有解决!!! 不多说了,Ribbon作为后端负载均衡器,比Nginx更注重的是请求分发而不是承担并发,可以直接感知后台动态变化来指定分发策略.它一共提供了7种负载均衡策略: 策略名 策略声明 策略描述 实现说明 BestAvailableRule public class BestAvailableRule extends ClientConfigEnabledRoundRobinRule 选择一个最小的并			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPB9YAb.html" rel="bookmark">简单测试Apache是如何完成负载均衡策略配置&lowbar;Linux</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				随着访问量的不断提升,以及对响应速度要求的苛刻,进行负载均衡设置就显得尤为重要了.公司的系统在最初设计的时候就已经考虑到了负载均衡的规划,www静态服务器配置了两台,由于初期项目时间紧,并且访问量并不高,所以当时只用了一台,另一台在内网中,只是进行了同步,并为发挥出效用来.此次就是对负载均衡的一个简单测试. 先介绍一下apache mod_proxy_balancer的几个配置规则: 将Apache作为LoadBalance前置机分别有三种不同的部署方式,分别是: 1 )轮询均衡策略的配置 进入			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5Z3L6z.html" rel="bookmark">Dubbo负载均衡策略</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				参考内容:http://www.roncoo.com/course/view/85d6008fe77c4199b0cdd2885eaeee53 负载均衡 (+) (#) 在集群负载均衡时,Dubbo提供了多种均衡策略,缺省为random随机调用. 可以自行扩展负载均衡策略,参见:负载均衡扩展 Random LoadBalance 随机,按权重设置随机概率. 在一个截面上碰撞的概率高,但调用量越大分布越均匀,而且按概率使用权重后也比较均匀,有利于动态调整提供者权重. 权重加倍 RoundRobin			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBgKk4M.html" rel="bookmark">多WAN口宽带路由器负载均衡策略</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				负载均衡策略多WAN口宽带路由器的最突出的技术就是&quot;负载均衡&quot;,是多WAN口宽带路由器最重要的特征.分配各WAN口的数据流量是多WAN口宽带路由器要解决的问题,根据策略的不同,负载均衡的实现方式也不同.常见和流行的负载均衡策略有以下三种:会话( Session )方式系统以会话数目为计数单位,所有会话按平均的比例均分到所有启用的WAN口.在接入的线路带宽不同时会出现不均衡,导致一个WAN口可能出现拥塞,而另一个却还有盈余.Weight round robin 方式也是按会话,但会话的比			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZ2A8Oz.html" rel="bookmark">Apache服务器实现负载均衡策略配置详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				随着访问量的不断提高,以及对响应速度的要求,进行负载均衡设置就显得非常必要了.公司的系统在最初设计的时候就已经考虑到了负载均衡的规 划,www静态服务器配置了两台,由于初期项目时间紧,并且访问量并不高,所以当时只用了一台,另一台在内网中,只是进行了同步,并为发挥出效用来.此次 就是对负载均衡的一个简单测试. 先介绍一下apache mod_proxy_balancer的几个配置规则: 将Apache作为LoadBalance前置机分别有三种不同的部署方式,分别是: 1 )轮询均衡策略的配置 进入			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boqn5Dp.html" rel="bookmark">几种软负载均衡策略分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				公司去年上了F5,好用是好用,但是费用太高昂了,所以最近一直在研究软负载均衡这一块儿,恰巧今年年初谷歌开源了seesaw,让自己可以绕过很多弯路.特此总结下之前了解的负载均衡策略. -Sunface 在分布式系统中,负载均衡是非常重要的环节,通过负载均衡将请求派发到网络中的一个或多个节点上进行处理.通常来说,负载均衡分为硬件负载均衡及软件负载均衡.硬件负载均衡,顾名思义,在服务器节点之间安装专门的硬件进行负载均衡的工作,F5便为其中的佼佼者.软件负载均衡则是通过在服务器上安装的特定的负载均衡软件			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVnNVYz.html" rel="bookmark">LVS-DR直接路由实现负载均衡示例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				要求:通过使用LVS的直接路由来实现服务器的负载均衡 注:在做实验之前一定要先关闭每台主机的防火墙与SELinux 拓扑图 LVS服务器配置: 1&gt; 开启转发功能 [root@localhost ~]# echo 1 &gt; /proc/sys/net/ipv4/ip_forward 2&gt; 安装lvs控制软件ipvsadm [root@localhost ~]# mount /dev/cdrom /mnt/cdrom mount: block device /dev/cdrom is wri			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzVGKnb.html" rel="bookmark" class="title">认识CSS样式clip&colon; 认识隐藏页面元素</a>
					<div>
						在页面上,我们经常会用到radio, 比如性别:男,女,保密. 但我们不喜欢默认的radio样式!我们会用其他的来替代. 我最初的做法是, 用label显示,设置radio为隐藏! (即display ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzVjmkz.html" rel="bookmark" class="title">Asp&period;net下的对象成员数据绑定器实现</a>
					<div>
						asp.net|对象|数据     用过MonoRail的朋友应该知道它提供的对象成员数据绑定功能非常方便,通过标记参数属性或方法就可以自动把提交回来的数据和对象成员进行绑定:有了这些方便的功能的确可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk20oOM.html" rel="bookmark" class="title">&lbrack;3D基础&rsqb;3D游戏中的各种旋转与基变换&lpar;2&rpar;</a>
					<div>
						终于开始着手写[3D基础]系列的第二篇文章了,这篇文章所将的内容相信对于很多人而言都是相当重要的,因为涉及到相机坐标系变换,BILLBOARD实现原理,凹凸映射切空间变换等课题.按以前的习惯,重要内容 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M91qWVM.html" rel="bookmark" class="title">编写多文档应用程序</a>
					<div>
						一.动态菜单与工具栏 文档应用程序-编写windows应用程序&quot;&gt; (未登录状态) (登陆状态) 实现原理: 1．菜单 BOOL SetMenu( HWND hWnd, // hand ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLm4Zb.html" rel="bookmark" class="title">OpenRisc入门（13）-or1200硬件环境搭建</a>
					<div>
						硬件环境需要我们自己手动将系统需要的外设添加到软核上,那么首先搭一个最简单的SOC,想想我们需要点什么? 软核or1200不用说了,上了CPU必须是要跑程序的,RAM是必须的,要下载程序代码,下载器是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5AmVmp.html" rel="bookmark" class="title">ap plet中应用JDBC访问数据库</a>
					<div>
						  ap plet是用Java语言编写的小应用程序,它能够嵌入在HTML中,并由WWW浏览器来解释执行.但是,如何在ap plet中处理Internet世界中大量的数据和分布在网络各个角落的各种各样的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLnyeb.html" rel="bookmark" class="title">使用超链接实现PPT幻灯片导航的方法</a>
					<div>
						  使用超链接实现PPT幻灯片导航的方法         1.打开需要创建超链接的幻灯片,选择需要创建超链接的对象,然后在&quot;插入&quot;选项卡的&quot;链接&quot;组中单击&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk2X5dM.html" rel="bookmark" class="title">photoshop滤镜教程：发黄老照片制作</a>
					<div>
						介绍非常逼真的老照片效果制作方法.教程的制作难点是照片纹理的制作.需要用到多种滤镜,制作出一些类似残缺线条的效果.然后把这些纹理应用到单色照片上面就可以看到非常古典的效果. 原图 最终效果 1.打开原 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3oxxkb.html" rel="bookmark" class="title">图片-控件listview项图绑定imagelist，imagelist最大才为256！怎么变大？急</a>
					<div>
						问题描述 控件listview项图绑定imagelist,imagelist最大才为256!怎么变大?急 控件listview项图绑定imagelist,imagelist最大才为256!怎么变大?急 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24gvop.html" rel="bookmark" class="title">hdu3339 In Action&lpar;Dijkstra&plus;01背包&rpar;</a>
					<div>
						/* 题意:有 n 个站点(编号1...n),每一个站点都有一个能量值,为了不让这些能量值连接起来,要用 坦克占领这个站点!已知站点的 之间的距离,每个坦克从0点出发到某一个站点,1 unit dis ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3Pg4p.html" rel="bookmark" class="title">mfc-VC&plus;&plus;6&period;0在MFC添加ACCESS 数据源出错</a>
					<div>
						问题描述 VC++6.0在MFC添加ACCESS 数据源出错 我在看MFC的视频的教程,按照视频里的方法,在VC里添加数据源,然后编译执行,编译没有出错,但是执行后就出现如下图片所示 求各位大神看看是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrQ3OM.html" rel="bookmark" class="title">iOS多线程开发之深入GCD</a>
					<div>
						iOS多线程开发之深入GCD 一.前言         在以前的一些系列博客中,对iOS中线程的管理做了总结,其中涵盖了GCD的相关基础知识:http://my.oschina.net/u/23408 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2PNmrp.html" rel="bookmark" class="title">惊现支付宝员工辞职信：终于知道阿里巴巴为何做大</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 业内流出,不知真假,如果是真的,终 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NjNaz.html" rel="bookmark" class="title">Storm Trident API 实践</a>
					<div>
						一.概要      1.1 Storm(简介)      Storm是一个实时的可靠地分布式流计算框架.      具体就不多说了,举个例子,它的一个典型的大数据实时计算应用场景:从Kafka消息队列 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boRw0Bz.html" rel="bookmark" class="title">java中 包里存放的是类名&period;java 还是类名&period;class&quest;</a>
					<div>
						问题描述 java中 包里存放的是类名.java 还是类名.class? 问题1 java中 包里存放的是类名.java 还是类名.class? 类名.java文件一定要放在所 属包目录下吗? 问题2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6vx3z.html" rel="bookmark" class="title">session-求详解，各位大神麻烦给我解析下下面的的语句，谢谢啦，小弟感激不尽</a>
					<div>
						问题描述 求详解,各位大神麻烦给我解析下下面的的语句,谢谢啦,小弟感激不尽 public List getList(String startTime, String endTime, String m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZRGaz.html" rel="bookmark" class="title">请教C&num;隔一段时间运行某段程序</a>
					<div>
						问题描述 publicpartialclassForm1:Form{privatestaticSystem.Timers.Timert;privatevoida(objectsource,Elapse ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXoWOz.html" rel="bookmark" class="title">iOS自动化测试的那些干货</a>
					<div>
						前言 如果有测试大佬发现内容不对,欢迎指正,我会及时修改. 大多数的iOS App(没有持续集成)迭代流程是这样的   也就是说,测试是发布之前的最后一道关卡.如果bug不能在测试中发现,那么bug  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKekqb.html" rel="bookmark" class="title">《Python 3程序开发指南（第2版&bull;修订版）》&mdash;&mdash;7&period;4 随机存取二进制文件</a>
					<div>
						7.4 随机存取二进制文件 前面几节中,工作的基础是程序的所有数据都是作为一个整体读入内存.进行适当处理,最后再作为整体写出.现代计算机具有很大的RAM容量,使得这种方法可以有效运作,即便对很大的数据 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYw6Ep.html" rel="bookmark" class="title">了解ASP&period;NET MVC几种ActionResult的本质：HttpStatusCodeResult &amp;amp&semi; RedirectResult&sol;RedirectToRouteResult</a>
					<div>
						在本系列的最后一篇,我们来讨论最后三个ActionResult:HttpStatusCodeResult.RedirectResult和RedirectToRouteResult .第一个用于实现针对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx00g0M.html" rel="bookmark" class="title">一篇文章教你用隐马尔科夫模型实现中文分词</a>
					<div>
						  什么问题用HMM解决 现实生活中有这样一类随机现象,在已知现在情况的条件下,未来时刻的情况只与现在有关,而与遥远的过去并无直接关系. 比如天气预测,如果我们知道&quot;晴天,多云,雨天&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyeK1kM.html" rel="bookmark" class="title">树形导航-js或jQuery怎样实现树形表</a>
					<div>
						问题描述 js或jQuery怎样实现树形表 请问 图片左侧是图形是怎样实现的 求高人指教 求代码 多谢多谢 解决方案 js 时间轴					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNnkA7M.html" rel="bookmark" class="title">如何在命令行中使用 ftp 命令上传和下载文件</a>
					<div>
						如何在命令行中使用 ftp 命令上传和下载文件 本文中,介绍在 Linux shell 中如何使用 ftp 命令.包括如何连接 FTP 服务器,上传或下载文件以及创建文件夹.尽管现在有许多不错的 FT ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJDYmp.html" rel="bookmark" class="title">《数据分析变革：大数据时代精准决策之道》一2&period;4 小结</a>
					<div>
						2.4 小结 从本章中我们获得的最重要的启发有以下几个. 不必管该如何定义大数据.我们要管的是哪些数据,无论大小,是分析需要的.定义不重要,结果才重要! 我们要保持业务问题导向.不要为了实现大数据技术 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoVeOM.html" rel="bookmark" class="title">发展循环经济 首钢从黑色冶金迈向&OpenCurlyDoubleQuote;绿色冶金&rdquo;</a>
					<div>
						中新社北京十一月十六日电 首钢总公司董事长朱继民在此间举行的中国国际矿业大会上说,首钢着力从&quot;黑色冶金&quot;向&quot;绿色冶金&quot;过渡,大力节约资源,发展循环经济. 据悉, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJv7Qp.html" rel="bookmark" class="title">《Python参考手册（第4版&bull;修订版）》&mdash;&mdash;2&period;8　装饰器</a>
					<div>
						2.8 装饰器 函数.方法或类定义的前面可以使用一个特殊的符号,称为装饰器,其目的是修改后面定义的行为.装饰器使用@符号表示,必须单独放在对应的函数.方法或类之前的那行上,例如: class Foo( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5QAJWp.html" rel="bookmark" class="title">画面效果引发网游界谁是王者大战</a>
					<div>
						(编译/小熙)随着&lt;TERA&gt;公测日益临近,很多韩国专家称,&lt;TERA&gt;的画面效果已经达到了韩游的巅峰,而作为目前韩国市场的绝对老大,&lt;永恒之塔&gt;似乎有点不认同所谓 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7wkZKz.html" rel="bookmark" class="title">《Adobe Illustrator CC经典教程》&mdash;第2课2&period;4节使用编组</a>
					<div>
						2.4 使用编组Adobe Illustrator CC经典教程将多个对象编组后,它们将被视为一个整体.这样,可以同时移动或变换很多对象,而不会影响它们各自的属性和相对位置. 2.4.1 将对象编组下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwyLZ5M.html" rel="bookmark" class="title">Win8如何从关机状态下启动直接进入Desktop</a>
					<div>
						&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp;   此文简单介绍一种通过修改注册表键值的方法将Win8从关 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYdNEVb.html" rel="bookmark" class="title">MaggieQ化身性感女特工比基尼热辣魅惑</a>
					<div>
						近日,Maggie Q的美剧新作&lt;尼基塔&gt;最新剧照 曝光.剧照中Maggie Q变身性感女特工,比基尼着装热辣无比. MaggieQ化身性感女特工 比基尼热辣魅惑[page] 近日,Mag ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.038 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
